## love 11.5

=== CMakeLists.txt ===
#
# Copyright (c) 2006-2023 LOVE Development Team
#
# This software is provided 'as-is', without any express or implied
# warranty.  In no event will the authors be held liable for any damages
# arising from the use of this software.
#
# Permission is granted to anyone to use this software for any purpose,
# including commercial applications, and to alter it and redistribute it
# freely, subject to the following restrictions:
#
# 1. The origin of this software must not be misrepresented; you must not
#    claim that you wrote the original software. If you use this software
#    in a product, an acknowledgment in the product documentation would be
#    appreciated but is not required.
# 2. Altered source versions must be plainly marked as such, and must not be
#    misrepresented as being the original software.
# 3. This notice may not be removed or altered from any source distribution.
#

if(${CMAKE_CURRENT_SOURCE_DIR} STREQUAL ${CMAKE_CURRENT_BINARY_DIR})
	# Protip: run cmake like this: cmake -G "<generator>" -H. -Bbuild
	message(FATAL_ERROR "Prevented in-tree build.")
endif()

cmake_minimum_required(VERSION 3.1)

project(love)

set(LOVE_EXE_NAME love)
set(LOVE_LIB_NAME liblove)

set(CMAKE_MODULE_PATH "${love_SOURCE_DIR}/extra/cmake" ${CMAKE_MODULE_PATH})
# Needed for shared libs on Linux. (-fPIC).
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

set (CMAKE_CXX_STANDARD 11)

if(APPLE)
	message(WARNING "CMake is not an officially supported build system for love on Apple platforms.")
	message(WARNING "Use the prebuilt .app or the xcode project in platform/xcode/ instead.")
endif()

if(MSVC OR MINGW)
	set(LOVE_CONSOLE_EXE_NAME lovec)
endif()

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
	set(LOVE_X64 TRUE)
	set(LOVE_TARGET_PLATFORM x64)
else()
	set(LOVE_X86 TRUE)
	set(LOVE_TARGET_PLATFORM x86)
endif()

if(APPLE)
	option(LOVE_JIT "Use LuaJIT" FALSE)
else()
	option(LOVE_JIT "Use LuaJIT" TRUE)
endif()
option(LOVE_MPG123 "Use mpg123" TRUE)

if(LOVE_JIT)
	if(APPLE)
		message(WARNING "JIT not supported yet on Mac.")
	endif()
	message(STATUS "LuaJIT: Enabled")
else()
	message(STATUS "LuaJIT: Disabled")
endif()

if(NOT LOVE_MPG123)
	add_definitions(-DLOVE_NOMPG123)
endif()

message(STATUS "Target platform: ${LOVE_TARGET_PLATFORM}")

if(POLICY CMP0072)
	cmake_policy(SET CMP0072 NEW)
endif()

if(POLICY CMP0063)
	cmake_policy(SET CMP0063 NEW)
endif()

find_package(OpenGL)

if(MEGA)
	# LOVE_MSVC_DLLS contains runtime DLLs that should be bundled with the love
	# binary (in e.g. the installer). Example: msvcp140.dll.
	set(LOVE_MSVC_DLLS ${MEGA_MSVC_DLLS})

	# LOVE_INCLUDE_DIRS contains the search directories for #include. It's mostly
	# not needed for MEGA builds, since almost all the libraries (except LuaJIT)
	# are CMake targets, causing include paths to be added automatically.
	set(LOVE_INCLUDE_DIRS)

	if(APPLE)
		# Some files do #include <SDL2/SDL.h>, but building with megasource
		# requires #include <SDL.h>.
		add_definitions(-DLOVE_MACOSX_SDL_DIRECT_INCLUDE)
	endif ()

	# SDL2 links with some DirectX libraries, and we apparently also
	# pull those libraries in for linkage because we link with SDL2.
	set(LOVE_LINK_DIRS ${SDL_LINK_DIR})

	set(LOVE_LINK_LIBRARIES
		${OPENGL_gl_LIBRARY}
		${MEGA_FREETYPE}
		${MEGA_LIBOGG}
		${MEGA_LIBVORBISFILE}
		${MEGA_LIBVORBIS}
		${MEGA_LIBTHEORA}
		${MEGA_MODPLUG}
		${MEGA_OPENAL}
		${MEGA_SDL2MAIN}
		${MEGA_SDL2}
		${MEGA_ZLIB}
	)

	# These DLLs are moved next to the love binary in a post-build step to
	# love runnable from inside Visual Studio.
	#
	# LOVE_MOVE_DLLS can contain CMake targets, in which case the target's
	# output is assumed to be a DLL, or it can contain paths to actual files.
	# We detect whether or not each item is a target, and take the appropriate
	# action.
	set(LOVE_MOVE_DLLS
		${MEGA_SDL2}
		${MEGA_OPENAL}
	)

	if(LOVE_MPG123)
		set(LOVE_LINK_LIBRARIES
			${LOVE_LINK_LIBRARIES}
			${MEGA_MPEG123}
		)
		set(LOVE_MOVE_DLLS
			${LOVE_MOVE_DLLS}
			${MEGA_MPEG123}
		)
	endif()

	if(LOVE_JIT)
		set(LOVE_LUA_LIBRARY ${MEGA_LUAJIT_LIB})
		# LOVE_EXTRA_DLLS are non-runtime DLLs which should be bundled with the
		# love binary in installers, etc. It's only needed for external
		# (non-CMake) targets, i.e. LuaJIT.
		set(LOVE_EXTRA_DLLS ${MEGA_LUAJIT_DLL})
		set(LOVE_EXTRA_DEPENDECIES luajit)

		set(LOVE_INCLUDE_DIRS
			${LOVE_INCLUDE_DIRS}
			${MEGA_LUAJIT_INCLUDE}
		)
		set(LOVE_LINK_LIBRARIES
			${LOVE_LINK_LIBRARIES}
			${LOVE_LUA_LIBRARY}
		)
		set(LOVE_MOVE_DLLS
			${LOVE_MOVE_DLLS}
			${MEGA_LUAJIT_DLL}
		)
	else()
		set(LOVE_LUA_LIBRARY ${MEGA_LUA51})

		set(LOVE_LINK_LIBRARIES
			${LOVE_LINK_LIBRARIES}
			${LOVE_LUA_LIBRARY}
		)
		set(LOVE_MOVE_DLLS
			${LOVE_MOVE_DLLS}
			${LOVE_LUA_LIBRARY}
		)
		# MEGA_LUA51 is a CMake target, so includes are handled
		# automatically.
	endif()
else()
	if(MSVC)
		message(FATAL_ERROR "
It is currently only possible to build with megasource or (experimental) mingw on Windows.
Please see https://github.com/love2d/megasource
")
	endif()

	find_package(Freetype REQUIRED)
	find_package(ModPlug REQUIRED)
	find_package(OpenAL REQUIRED)
	find_package(OpenGL REQUIRED)
	find_package(SDL2 REQUIRED CONFIG COMPONENTS SDL2main)
	find_package(Theora REQUIRED)
	find_package(Vorbis REQUIRED)
	find_package(ZLIB REQUIRED)
	find_package(Ogg REQUIRED)

	# required for enet
	add_definitions(-D HAS_SOCKLEN_T)

	set(LOVE_INCLUDE_DIRS
		${SDL2_INCLUDE_DIRS}
		${FREETYPE_INCLUDE_DIRS}
		${VORBIS_INCLUDE_DIR}
		${OPENAL_INCLUDE_DIR}
		${ZLIB_INCLUDE_DIRS}
		${MODPLUG_INCLUDE_DIR}
		${OGG_INCLUDE_DIR}
		${THEORA_INCLUDE_DIR}
	)

	set(LOVE_LINK_LIBRARIES
		${OPENGL_gl_LIBRARY}
		${SDL2_LIBRARIES}
		${FREETYPE_LIBRARY}
		${OPENAL_LIBRARY}
		${MODPLUG_LIBRARY}
		${THEORA_LIBRARY}
		${THEORADEC_LIBRARY}
		${VORBISFILE_LIBRARY}
		${LOVE_LUA_LIBRARY}
		${OGG_LIBRARY}
		${ZLIB_LIBRARY}
	)

	if(LOVE_MPG123)
		find_package(MPG123 REQUIRED)
		set(LOVE_LINK_LIBRARIES
			${LOVE_LINK_LIBRARIES}
			${MPG123_LIBRARY}
		)
		set(LOVE_INCLUDE_DIRS
			${LOVE_INCLUDE_DIRS}
			${MPG123_INCLUDE_DIR}
		)
	endif()

	if(LOVE_JIT)
		find_package(LuaJIT REQUIRED)
		set(LOVE_LUA_LIBRARY ${LUAJIT_LIBRARY})
		set(LOVE_LUA_INCLUDE_DIR ${LUAJIT_INCLUDE_DIR})
	else()
		find_package(Lua51 REQUIRED)
		set(LOVE_LUA_LIBRARY ${LUA_LIBRARY})
		set(LOVE_LUA_INCLUDE_DIR ${LUA_INCLUDE_DIR})
	endif()

	set(LOVE_INCLUDE_DIRS
		${LOVE_INCLUDE_DIRS}
		${LOVE_LUA_INCLUDE_DIR}
	)
	set(LOVE_LINK_LIBRARIES
		${LOVE_LINK_LIBRARIES}
		${LOVE_LUA_LIBRARY}
	)

endif()

###
### No Megasource-specific stuff beyond this point!
###

if(MSVC)
	set(DISABLE_WARNING_FLAG -W0)
else()
	set(DISABLE_WARNING_FLAG -w)
endif()

function(love_disable_warnings ARG_TARGET)
	get_target_property(OLD_FLAGS ${ARG_TARGET} COMPILE_FLAGS)
	set(NEW_FLAGS ${DISABLE_WARNING_FLAG})
	if(OLD_FLAGS)
		set(NEW_FLAGS "${OLD_FLAGS} ${NEW_FLAGS}")
	endif()
	set_target_properties(${ARG_TARGET} PROPERTIES COMPILE_FLAGS ${NEW_FLAGS})
endfunction()

#
# common
#

set(LOVE_SRC_COMMON
	src/common/b64.cpp
	src/common/b64.h
	src/common/Color.h
	src/common/config.h
	src/common/Data.cpp
	src/common/Data.h
	src/common/delay.cpp
	src/common/delay.h
	src/common/deprecation.cpp
	src/common/deprecation.h
	src/common/EnumMap.h
	src/common/Exception.cpp
	src/common/Exception.h
	src/common/floattypes.cpp
	src/common/floattypes.h
	src/common/int.h
	src/common/math.h
	src/common/Matrix.cpp
	src/common/Matrix.h
	src/common/memory.cpp
	src/common/memory.h
	src/common/Module.cpp
	src/common/Module.h
	src/common/Object.cpp
	src/common/Object.h
	src/common/Optional.h
	src/common/pixelformat.cpp
	src/common/pixelformat.h
	src/common/Reference.cpp
	src/common/Reference.h
	src/common/runtime.cpp
	src/common/runtime.h
	src/common/Stream.cpp
	src/common/Stream.h
	src/common/StringMap.cpp
	src/common/StringMap.h
	src/common/types.cpp
	src/common/types.h
	src/common/utf8.cpp
	src/common/utf8.h
	src/common/Variant.cpp
	src/common/Variant.h
	#src/common/Vector.cpp # Vector.cpp is empty.
	src/common/Vector.h
	src/common/version.h
)

if (APPLE)
	set(LOVE_SRC_COMMON ${LOVE_SRC_COMMON}
		src/common/macosx.mm
	)
	set(LOVE_LINK_LIBRARIES ${LOVE_LINK_LIBRARIES} objc)
	set(LOVE_LINK_LIBRARIES ${LOVE_LINK_LIBRARIES} "-framework CoreFoundation")
	set(LOVE_LINK_LIBRARIES ${LOVE_LINK_LIBRARIES} "-framework AppKit")
endif()

source_group("common" FILES ${LOVE_SRC_COMMON})

#
# love.audio
#

set(LOVE_SRC_MODULE_AUDIO_ROOT
	src/modules/audio/Audio.cpp
	src/modules/audio/Audio.h
	src/modules/audio/Source.cpp
	src/modules/audio/Source.h
	src/modules/audio/RecordingDevice.cpp
	src/modules/audio/RecordingDevice.h
	src/modules/audio/Filter.cpp
	src/modules/audio/Filter.h
	src/modules/audio/Effect.cpp
	src/modules/audio/Effect.h
	src/modules/audio/wrap_Audio.cpp
	src/modules/audio/wrap_Audio.h
	src/modules/audio/wrap_Source.cpp
	src/modules/audio/wrap_Source.h
	src/modules/audio/wrap_RecordingDevice.cpp
	src/modules/audio/wrap_RecordingDevice.h
)

set(LOVE_SRC_MODULE_AUDIO_NULL
	src/modules/audio/null/Audio.cpp
	src/modules/audio/null/Audio.h
	src/modules/audio/null/Source.cpp
	src/modules/audio/null/Source.h
	src/modules/audio/null/RecordingDevice.cpp
	src/modules/audio/null/RecordingDevice.h
)

set(LOVE_SRC_MODULE_AUDIO_OPENAL
	src/modules/audio/openal/Audio.cpp
	src/modules/audio/openal/Audio.h
	src/modules/audio/openal/Pool.cpp
	src/modules/audio/openal/Pool.h
	src/modules/audio/openal/Source.cpp
	src/modules/audio/openal/Source.h
	src/modules/audio/openal/RecordingDevice.cpp
	src/modules/audio/openal/RecordingDevice.h
	src/modules/audio/openal/Filter.cpp
	src/modules/audio/openal/Filter.h
	src/modules/audio/openal/Effect.cpp
	src/modules/audio/openal/Effect.h
)

set(LOVE_SRC_MODULE_AUDIO
	${LOVE_SRC_MODULE_AUDIO_ROOT}
	${LOVE_SRC_MODULE_AUDIO_NULL}
	${LOVE_SRC_MODULE_AUDIO_OPENAL}
)

source_group("modules\\audio" FILES ${LOVE_SRC_MODULE_AUDIO_ROOT})
source_group("modules\\audio\\null" FILES ${LOVE_SRC_MODULE_AUDIO_NULL})
source_group("modules\\audio\\openal" FILES ${LOVE_SRC_MODULE_AUDIO_OPENAL})

#
# love.data
#

set(LOVE_SRC_MODULE_DATA
	src/modules/data/ByteData.cpp
	src/modules/data/ByteData.h
	src/modules/data/CompressedData.cpp
	src/modules/data/CompressedData.h
	src/modules/data/Compressor.cpp
	src/modules/data/Compressor.h
	src/modules/data/DataModule.cpp
	src/modules/data/DataModule.h
	src/modules/data/DataView.cpp
	src/modules/data/DataView.h
	src/modules/data/HashFunction.cpp
	src/modules/data/HashFunction.h
	src/modules/data/wrap_ByteData.cpp
	src/modules/data/wrap_ByteData.h
	src/modules/data/wrap_CompressedData.cpp
	src/modules/data/wrap_CompressedData.h
	src/modules/data/wrap_Data.cpp
	src/modules/data/wrap_Data.h
	src/modules/data/wrap_DataModule.cpp
	src/modules/data/wrap_DataModule.h
	src/modules/data/wrap_DataView.cpp
	src/modules/data/wrap_DataView.h
)

source_group("modules\\data" FILES ${LOVE_SRC_MODULE_DATA})

#
# love.event
#

set(LOVE_SRC_MODULE_EVENT_ROOT
	src/modules/event/Event.cpp
	src/modules/event/Event.h
	src/modules/event/wrap_Event.cpp
	src/modules/event/wrap_Event.h
)

set(LOVE_SRC_MODULE_EVENT_SDL
	src/modules/event/sdl/Event.cpp
	src/modules/event/sdl/Event.h
)

set(LOVE_SRC_MODULE_EVENT
	${LOVE_SRC_MODULE_EVENT_ROOT}
	${LOVE_SRC_MODULE_EVENT_SDL}
)

source_group("modules\\event" FILES ${LOVE_SRC_MODULE_EVENT_ROOT})
source_group("modules\\event\\sdl" FILES ${LOVE_SRC_MODULE_EVENT_SDL})

#
# love.filesystem
#

set(LOVE_SRC_MODULE_FILESYSTEM_ROOT
	src/modules/filesystem/DroppedFile.cpp
	src/modules/filesystem/DroppedFile.h
	src/modules/filesystem/File.cpp
	src/modules/filesystem/File.h
	src/modules/filesystem/FileData.cpp
	src/modules/filesystem/FileData.h
	src/modules/filesystem/Filesystem.cpp
	src/modules/filesystem/Filesystem.h
	src/modules/filesystem/wrap_DroppedFile.cpp
	src/modules/filesystem/wrap_DroppedFile.h
	src/modules/filesystem/wrap_File.cpp
	src/modules/filesystem/wrap_File.h
	src/modules/filesystem/wrap_FileData.cpp
	src/modules/filesystem/wrap_FileData.h
	src/modules/filesystem/wrap_Filesystem.cpp

=== debian/changelog ===
love (11.5-2build1) resolute; urgency=medium

  * Rebuild against latest libtheora

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:19:34 -0500

love (11.5-2) unstable; urgency=medium

  * Revert "switch to libluajit2-5.1-dev" (Closes: #1072351)
  * Enablue build on loong64 (Closes: #1059142)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 01 Jun 2024 20:23:59 +0200

love (11.5-1) unstable; urgency=medium

  * New upstream version 11.5
  * add myself as uploader
  * add debian/gbp.conf
  * debian/watch: Use GitHub /tags rather than /releases page.
  * update build dependencies:
    * libfreetype6-dev -> libfreetype-dev
    * libluajit-5.1-dev -> libluajit2-5.1-dev
    * pkg-config -> pkgconf

  [ Janitor ]
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

 -- Alexandre Detiste <tchet@debian.org>  Sun, 11 Feb 2024 14:10:15 +0100

=== debian/control ===
Source: love
Section: interpreters
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
 Miriam Ruiz <miriam@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libfreetype-dev,
 liblua5.1-0-dev,
 libluajit-5.1-dev [!alpha !ia64 !loong64 !ppc64el !riscv64 !sh4 !s390x],
 libmodplug-dev,
 libmpg123-dev,
 libogg-dev,
 libopenal-dev,
 libphysfs-dev,
 libsdl2-dev,
 libstb-dev,
 libtheora-dev,
 libtool,
 libvorbis-dev,
 lua5.2 | lua5.1,
 pkgconf,
 zip,
 zlib1g-dev
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://love2d.org/
Vcs-Git: https://salsa.debian.org/games-team/love.git
Vcs-Browser: https://salsa.debian.org/games-team/love

Package: love
Architecture: alpha any-i386 any-amd64 arm64 armel armhf ia64 mips64el mipsel ppc64el riscv64 sh4 x32
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 binfmt-support | systemd
Description: 2D game development framework based on Lua and OpenGL
 LÖVE was created to be a user-friendly engine in which simple (or
 complicated) games could be made without having extensive knowledge
 of system or graphics functions and without having to dedicate time
 towards developing the same engine features time and time again.
 .
 Developed with cross-platform implementation in mind, it utilizes the
 latest open source libraries to deliver a similar game experience,
 independent of operating system. By relying on the Lua scripting language
 for game-specific programming, it allows even the novice game creator to
 quickly and efficiently develop an idea into a fully working game.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildtools.mk

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# does not link without pthread
# undefined reference to symbol 'pthread_sigmask@@GLIBC_2.2.5'
#export DEB_LDFLAGS_MAINT_APPEND = -lpthread

LUA_IMPL = $(shell $(PKG_CONFIG) luajit && echo luajit || echo lua)

%:
	dh $@

override_dh_auto_configure:
	platform/unix/automagic
	ln -sf /usr/include/stb/stb_image.h src/libraries/stb/stb_image.h
#	dh_auto_configure -- -DCMAKE_SKIP_RPATH=ON
	dh_auto_configure -- --disable-shared --enable-static --with-lua=$(LUA_IMPL)
	# rebuild C++ header files:
	cd src/scripts/ && lua auto.lua boot nogame

override_dh_auto_install:
	# skip dh_auto_install as we install all files via dh_install

override_dh_install:
	dh_install
	#install -m755 -D obj-*/love debian/love/usr/bin/love-$(DEB_VERSION_UPSTREAM)
	install -m755 -D src/love debian/love/usr/bin/love-$(DEB_VERSION_UPSTREAM)
	install -m644 -D debian/love.binfmt debian/love/usr/share/binfmts/love
	install -m644 -D platform/unix/love.6 debian/love/usr/share/man/man6/love-$(DEB_VERSION_UPSTREAM).6

=== debian/watch ===
version=4
https://github.com/love2d/love/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
